<template>
  <div>
    <app-modal
      v-if="showDeleteModal"
      @cancel="showDeleteModal = false"
      @confirm="onDelete"
      labelConfirm="Delete"
    >
      <template v-slot:header>Confirm your action</template>
      <template v-slot:body>Delete this user for sure?</template>
    </app-modal>
    <h2 v-if="editMode">Edit user</h2>
    <h2 v-else>Create a new user</h2>
    <form @submit.prevent="onSubmit" enctype="multipart/form-data">
      <div class="form-group">
        <label for="username">Username</label>
        <input
          type="text"
          class="form-control"
          id="username"
          v-model="entity.username"
          autocomplete="off"
          :disabled="editMode"
        />
      </div>

      <div class="form-group">
        <label for="email">Email</label>
        <input
          type="text"
          class="form-control"
          id="email"
          v-model="entity.email"
          autocomplete="off"
        />
      </div>

      <div class="form-group">
        <label for="password">Password</label>
        <input
          :type="passwordType"
          class="form-control flex-grow-1"
          id="password"
          v-model="entity.password"
          autocomplete="off"
        />

        <small
          v-if="editMode"
          class="text-muted"
        >Leave blank if you don't want to change the current password</small>
      </div>

      <div class="form-group">
        <label for="passwordConfirmation">Password confirmation</label>
        <input
          :type="passwordType"
          class="form-control flex-grow-1"
          id="passwordConfirmation"
          v-model="passwordConfirmation"
          autocomplete="off"
        />
        <small
          v-if="editMode"
          class="text-muted"
        >Leave blank if you don't want to change the current password</small>
      </div>

      <div class="d-flex">
        <div class="form-check mb-2 ml-auto">
          <input
            class="form-check-input"
            type="checkbox"
            id="cbShowPasswords"
            v-model="showPassword"
          />
          <label class="form-check-label" for="cbShowPasswords">Show passwords</label>
        </div>
      </div>

      <hr />
      <div class="d-flex">
        <div v-if="editMode">
          <button
            type="button"
            class="btn btn-outline-danger"
            @click="showDeleteModal = true"
          >Delete</button>
        </div>
        <button type="button" class="btn btn-outline ml-auto" @click="onCancel">Cancel</button>
        <input type="submit" value="Save" class="btn btn-primary" />
      </div>
    </form>
    <app-feedback v-if="status" class="mt-4">{{status}}</app-feedback>
  </div>
</template>

<script>
import ObjectId from "bson-objectid";
import api from "@/services/api.service";

export default {
  data() {
    return {
      editMode: true,
      availablePermissions: [],
      showDeleteModal: false,
      showPassword: false,
      passwordConfirmation: "",
      status: "",
      entity: {
        _id: "",
        username: "",
        email: "",
        permissions: [],
        token: "",
        password: "",
        authProviders: []
      }
    };
  },
  computed: {
    passwordType() {
      return this.showPassword ? "text" : "password";
    }
  },
  methods: {
    onCancel() {
      this.$router.push("/users");
    },
    async onDelete() {
      this.showDeleteModal = false;
      const deleteUrl = `/users/${this.entity._id}`;
      await api.delete(deleteUrl);
      this.$router.push("/users");
    },
    async onSubmit() {
      if (this.entity.password !== this.passwordConfirmation) {
        this.status = "Passwords do not match";
        return;
      }

      const data = this.entity;
      const method = this.editMode ? "put" : "post";
      const url = this.editMode ? `/users/${this.entity._id}` : "/users";

      try {
        await api.customRequest({
          method,
          url,
          data
        });
        this.$router.push(`/users/${this.entity._id}`);
      } catch (err) {
        console.log(err);
      }
    }
  },
  async created() {
    this.editMode = !this.$route.matched.some(
      ({ name }) => name === "users-new"
    );

    this.entity._id = new ObjectId();

    if (this.editMode) {
      try {
        const { id } = this.$route.params;
        const { data } = await api.get(`/users/${id}`);
        this.entity = { ...this.entity, ...data };
        //this.entity.partners = data.partners.map(p => p._id);
      } catch (e) {
        console.log("something went wrong:", e);
      }
    }
  }
};
</script>


